/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.system.framework;

import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Desktop;
import java.io.File;
import java.net.URI;
import java.util.HashMap;
import java.util.Map;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.UIManager;
import javax.swing.WindowConstants;
import org.apache.log4j.Logger;
import org.visnow.vn.lib.utils.SwingInstancer;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.UIManagerKey;
import org.visnow.vn.system.utils.usermessage.Level;
import org.visnow.vn.system.utils.usermessage.UserMessage;

/**
 *
 * @author szpak
 */
public class StartPagePanel extends javax.swing.JPanel
{

    private static final Logger LOGGER = Logger.getLogger(StartPagePanel.class);

    /**
     * Creates new form StartPagePanel
     */
    public StartPagePanel()
    {
        initComponents();
        postInitComponents();
    }

    private void postInitComponents()
    {
        if (VisNow.get() != null) {
            showOnStartupCheckBox.setSelected(!VisNow.get().getMainConfig().isStartPageHidden());
            jLabel2.setText(VisNow.TITLE + " v" + VisNow.getVersionNumber() + " build "+ VisNow.getBuildNumber());
        }
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        headerPanel = new javax.swing.JPanel();
        menuBgPanel = new org.visnow.vn.gui.widgets.ImageBackgroundPanel();
        menuPanel = new javax.swing.JPanel();
        aboutLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        demosLabel = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        whatsNewLabel = new javax.swing.JLabel();
        showOnStartupCheckBox = new javax.swing.JCheckBox();
        contentCardPanel = new javax.swing.JPanel();
        demosScrollPane = new javax.swing.JScrollPane();
        demosPanel = new org.visnow.vn.gui.widgets.GradientBackgroundPanel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        aboutScrollPane = new javax.swing.JScrollPane();
        aboutPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        whatsNewScrollPane = new javax.swing.JScrollPane();
        whatsNewPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        footerPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        vendorLabel = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        headerPanel.setBackground(new java.awt.Color(200, 221, 242));
        headerPanel.setBorder(javax.swing.BorderFactory.createMatteBorder(0, 0, 4, 0, new java.awt.Color(76, 77, 248)));
        headerPanel.setLayout(new java.awt.GridBagLayout());

        menuBgPanel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/gfx/logo_horizontal_265x64_white_outlined.png"))); // NOI18N
        menuBgPanel.setOpaque(false);
        menuBgPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        menuPanel.setOpaque(false);
        menuPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 10));

        aboutLabel.setFont(aboutLabel.getFont().deriveFont((float)12));
        aboutLabel.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.disabledForeground"));
        aboutLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        aboutLabel.setText("About");
        aboutLabel.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        aboutLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuClicked(evt);
            }
        });
        menuPanel.add(aboutLabel);

        jLabel5.setFont(jLabel5.getFont().deriveFont((float)12));
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel5.setText("|");
        menuPanel.add(jLabel5);

        demosLabel.setFont(demosLabel.getFont().deriveFont((float)12));
        demosLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        demosLabel.setText("Demos");
        demosLabel.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        demosLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuClicked(evt);
            }
        });
        menuPanel.add(demosLabel);

        jLabel7.setFont(jLabel7.getFont().deriveFont((float)12));
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel7.setText("|");
        menuPanel.add(jLabel7);

        whatsNewLabel.setFont(whatsNewLabel.getFont().deriveFont((float)12));
        whatsNewLabel.setForeground(javax.swing.UIManager.getDefaults().getColor("Label.disabledForeground"));
        whatsNewLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        whatsNewLabel.setText("What's new");
        whatsNewLabel.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        whatsNewLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuClicked(evt);
            }
        });
        menuPanel.add(whatsNewLabel);

        menuBgPanel.add(menuPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(65, 40, -1, -1));

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        headerPanel.add(menuBgPanel, gridBagConstraints);

        showOnStartupCheckBox.setFont(showOnStartupCheckBox.getFont().deriveFont((float)12));
        showOnStartupCheckBox.setSelected(true);
        showOnStartupCheckBox.setText("show on startup");
        showOnStartupCheckBox.setFocusable(false);
        showOnStartupCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        showOnStartupCheckBox.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        showOnStartupCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showOnStartupCheckBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 10);
        headerPanel.add(showOnStartupCheckBox, gridBagConstraints);

        add(headerPanel, java.awt.BorderLayout.NORTH);

        contentCardPanel.setLayout(new java.awt.CardLayout());

        demosScrollPane.setBorder(null);

        demosPanel.setBackground(new java.awt.Color(255, 255, 255));
        demosPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(40, 20, 20, 20));
        demosPanel.setBackground2(new java.awt.Color(166, 166, 166));
        demosPanel.setLayout(new java.awt.GridBagLayout());

        jLabel10.setFont(jLabel10.getFont().deriveFont(jLabel10.getFont().getSize()+3f));
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel10.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/system/framework/resources/startEar.png"))); // NOI18N
        jLabel10.setText("<html><b>Human ear</b><br/><br/>\nTomogram of human ear.<br/> Here shown as isosurface<br/> along with 2D and 1D slices<br/> followed by planar graph.<br/></html>");
        jLabel10.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel10.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jLabel10.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel10MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 40, 20);
        demosPanel.add(jLabel10, gridBagConstraints);

        jLabel11.setFont(jLabel11.getFont().deriveFont(jLabel11.getFont().getSize()+3f));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel11.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/system/framework/resources/startDental.png"))); // NOI18N
        jLabel11.setText("<html><b>Panoramic X-ray</b><br/><br/> Pantomogram evaluation<br/> with use of convolution<br/> filter and isolines.<br/></html>");
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel11.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jLabel11.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel11MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 40, 0);
        demosPanel.add(jLabel11, gridBagConstraints);

        jLabel13.setFont(jLabel13.getFont().deriveFont(jLabel13.getFont().getSize()+3f));
        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel13.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/system/framework/resources/startEarth.png"))); // NOI18N
        jLabel13.setText("<html><b>Orography 3D</b><br/><br/>\nEurope orography height<br/>\nmap projected on sphere<br/>\nembossed with graph 3D.</br></html>");
        jLabel13.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel13.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jLabel13.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel13MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(40, 0, 0, 20);
        demosPanel.add(jLabel13, gridBagConstraints);

        jLabel12.setFont(jLabel12.getFont().deriveFont(jLabel12.getFont().getSize()+3f));
        jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel12.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/system/framework/resources/startFoot.png"))); // NOI18N
        jLabel12.setText("<html><b>Foot CT</b><br/><br/>\nSample volume rendering<br/>\nof regular, orthogonal field<br/>\nwhich resolution was sized<br/> \ndown.<br/>\nScene completed with<br/>\n3D axes.<br/></html>");
        jLabel12.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel12.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jLabel12.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel12MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(40, 0, 0, 0);
        demosPanel.add(jLabel12, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        demosPanel.add(filler1, gridBagConstraints);

        demosScrollPane.setViewportView(demosPanel);

        contentCardPanel.add(demosScrollPane, "demos");

        aboutScrollPane.setBorder(null);

        aboutPanel.setLayout(new java.awt.BorderLayout());

        jLabel3.setFont(jLabel3.getFont().deriveFont((float)15));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setText("<html><b>Welcome to VisNow</b><br/><br/>  VisNow is a generic visualization framework.<br/><br/>  It is a modular data flow driven platform enabling users<br/> to create schemes for data visualization, visual analysis, <br/> data processing and simple simulations. <br/><br/>  Motivated by 'Read and Watch' idea, VisNow shows the data<br/> as soon and fast as possible giving further opportunity<br/> for processing and more in-depth visualization. In a few steps<br/> it can create professional images and movies as well as<br/> discover unknown information hidden in datasets.<br/><br/>  Take a look at Demos to see some of the features of VisNow. </html>");
        aboutPanel.add(jLabel3, java.awt.BorderLayout.CENTER);

        aboutScrollPane.setViewportView(aboutPanel);

        contentCardPanel.add(aboutScrollPane, "about");

        whatsNewScrollPane.setBorder(null);

        whatsNewPanel.setLayout(new java.awt.BorderLayout());

        jLabel1.setFont(jLabel1.getFont().deriveFont((float)15));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("<html><b>What's new in VisNow v1.4.0</b> <br><br> \n<p>Major changes:<br/> \n<ul> \n<li>visnow.org rebranding</li>\n<li>New Point Field data type with large dataset support and lower memory footprint</li>  \n<li><i>LAS reader</i> module for LIDAR point cloud data support</li>  \n<li><i>HDF5/CDM4 reader</i> module for reading Common Data Model (CDM) formats,<br>including NetCDF, HDF5, GRIB, etc.</li>  \n<li><i>HDF5 writer</i> module for saving VisNow fields in HDF5 format</li>  \n<li>Updated <i>CSV reader</i> with more functionality</li>  \n<li>Updated <i>component calculator</i> module with new user interface, new multi-argument<br>functions, mask and coordinates support, and some bugfixes</li>  \n<li><i>differential operations</i> module now supports time derivatives</li>  \n<li>Refreshed movie creation panel</li>  \n<li>Added even more support for physical units</li>  \n<li>Extended VNF header error notification in <i>VisNow field reader</i> module</li>    \n</ul> </p> \n<p>Major bugfixes:<br/> \n<ul> \n<li>Rendering library upgraded to new Java3D/JOGL versions</li>  \n<li>Lots of code optimizations</li>  \n<li>Resolved a number of VisNow freezes on newer operating systems</li>  \n<li>Fixed problems in <i>graph 3d</i> and <i>line probe</i> modules</li>  \n<li>Fixed  issues in writing ASCII VNF files</li>  \n<li>Fixed problems in <i>flow visualization</i> module</li>  \n<li>Fixed problems with 1D fields rendering</li>  \n</ul> </p> </html>\t");
        whatsNewPanel.add(jLabel1, java.awt.BorderLayout.CENTER);

        whatsNewScrollPane.setViewportView(whatsNewPanel);

        contentCardPanel.add(whatsNewScrollPane, "whatsnew");

        add(contentCardPanel, java.awt.BorderLayout.CENTER);

        footerPanel.setBackground(new java.awt.Color(255, 255, 255));
        footerPanel.setBorder(javax.swing.BorderFactory.createMatteBorder(4, 0, 0, 0, new java.awt.Color(76, 77, 248)));
        footerPanel.setLayout(new java.awt.GridBagLayout());

        jLabel2.setFont(jLabel2.getFont().deriveFont((float)10));
        jLabel2.setForeground(new java.awt.Color(153, 153, 153));
        jLabel2.setText("VisNow");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 7, 1, 10);
        footerPanel.add(jLabel2, gridBagConstraints);

        vendorLabel.setFont(vendorLabel.getFont().deriveFont((float)10));
        vendorLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/gfx/logo_org_horizontal_183x32_black.png"))); // NOI18N
        vendorLabel.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        vendorLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        vendorLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                vendorLabelMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        footerPanel.add(vendorLabel, gridBagConstraints);

        add(footerPanel, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void menuClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_menuClicked
        JLabel menuItem = (JLabel) evt.getSource();
        Map<JLabel, String> cardsMap = new HashMap<JLabel, String>()
        {
            {
                put(aboutLabel, "about");
                put(demosLabel, "demos");
                put(whatsNewLabel, "whatsnew");
            }
        };

        for (JLabel label : cardsMap.keySet())
            label.setForeground((Color) UIManager.get(UIManagerKey.Label_disabledForeground.getKey()));

        menuItem.setForeground((Color) UIManager.get(UIManagerKey.Label_foreground.getKey()));

        ((CardLayout) contentCardPanel.getLayout()).show(contentCardPanel, cardsMap.get(menuItem));
    }//GEN-LAST:event_menuClicked

    private void vendorLabelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_vendorLabelMouseClicked
        try {
            Desktop.getDesktop().browse(URI.create("https://www.visnow.org"));
        } catch (Exception ex) {
            VisNow.get().userMessageSend(null, "Can't start browser", "Can't start browser on this platform (JAVA error).<br/>Please browse to https://www.visnow.org", org.visnow.vn.system.utils.usermessage.Level.WARNING);
            LOGGER.info("Can't start browser", ex);
        }
    }//GEN-LAST:event_vendorLabelMouseClicked

    private long waitCursorStartTime;

    private void waitCursor()
    {
        final long cursorTimeoutMs = 15_000;
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

        boolean isWaitCursor = System.currentTimeMillis() - waitCursorStartTime < cursorTimeoutMs;
        waitCursorStartTime = System.currentTimeMillis();
        
        if (!isWaitCursor)
            new Thread(new Runnable()
            {
                @Override
                public void run()
                {
                    try {
                        while (System.currentTimeMillis() - waitCursorStartTime < cursorTimeoutMs) {
                            setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                            Thread.sleep(107);
                        }
                    } catch (InterruptedException ex) {
                        LOGGER.error("Interrupted", ex);
                    }
                    SwingInstancer.swingRunLater(() -> {
                        setCursor(Cursor.getDefaultCursor());
                    });    

                }
            }).start();
    }

    private void loadFromFile(String filename)
    {
        waitCursor();
        VisNow.get().userMessageSend(new UserMessage("", "VisNow", "Loading \"" + filename + "\"", "Loading network from file " + filename, Level.INFO));
        VisNow.get().getMainWindow().menu.betaOpenFile(new File(filename));
    }

    private void jLabel10MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel10MouseClicked
        loadFromFile("sample_data/ear_iso.vna");
    }//GEN-LAST:event_jLabel10MouseClicked

    private void jLabel12MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel12MouseClicked
        loadFromFile("sample_data/footct_crop_volume_axes.vna");
    }//GEN-LAST:event_jLabel12MouseClicked

    private void jLabel11MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel11MouseClicked
        loadFromFile("sample_data/pantomogram_convolution_isolines.vna");
    }//GEN-LAST:event_jLabel11MouseClicked

    private void showOnStartupCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showOnStartupCheckBoxActionPerformed
        boolean hidden = !showOnStartupCheckBox.isSelected();
        if (hidden != VisNow.get().getMainConfig().isStartPageHidden()) {
            VisNow.get().getMainConfig().setStartPageHidden(hidden);
            VisNow.get().getMainConfig().saveConfig();
        }
    }//GEN-LAST:event_showOnStartupCheckBoxActionPerformed

    private void jLabel13MouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_jLabel13MouseClicked
    {//GEN-HEADEREND:event_jLabel13MouseClicked
        loadFromFile("sample_data/world_radial_graph3D.vna");
    }//GEN-LAST:event_jLabel13MouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel aboutLabel;
    private javax.swing.JPanel aboutPanel;
    private javax.swing.JScrollPane aboutScrollPane;
    private javax.swing.JPanel contentCardPanel;
    private javax.swing.JLabel demosLabel;
    private org.visnow.vn.gui.widgets.GradientBackgroundPanel demosPanel;
    private javax.swing.JScrollPane demosScrollPane;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JPanel footerPanel;
    private javax.swing.JPanel headerPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private org.visnow.vn.gui.widgets.ImageBackgroundPanel menuBgPanel;
    private javax.swing.JPanel menuPanel;
    private javax.swing.JCheckBox showOnStartupCheckBox;
    private javax.swing.JLabel vendorLabel;
    private javax.swing.JLabel whatsNewLabel;
    private javax.swing.JPanel whatsNewPanel;
    private javax.swing.JScrollPane whatsNewScrollPane;
    // End of variables declaration//GEN-END:variables
    public static void main(String[] args)
    {
        StartPagePanel p = new StartPagePanel();
        JFrame f = new JFrame();
        f.add(p);
        f.pack();
        f.setVisible(true);
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    }
}
